<ui:composition xmlns:h="http://java.sun.com/jsf/html" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:f="http://java.sun.com/jsf/core"
                xmlns:rich="http://richfaces.org/rich" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:a4j="http://richfaces.org/a4j" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:c="http://java.sun.com/jstl/core"
                xmlns="http://www.w3.org/1999/xhtml">
    <!-- parameters: -->
    <!--    <ui:param name="document" value="#{validationBeanGui.presenter.document}"/>-->
    <!--    <ui:param name="renderer" value="#{renderer}"/>-->
    <!--    <ui:param name="options" value="caption: net.ihe.gazelle.document.prettified-content"/>-->
    <!--    <ui:param name="documentViewerStyle" value="document-long-viewer"/>-->
    <rich:tab id="#{renderer.id}" name="#{renderer.code}" header="#{renderer.title}">
        #{renderer.setOptions(renderer.mergeOptions(options))}
        <c:set var="opt" value="#{renderer.options}"/>
        <c:choose>
            <c:when test="#{renderer.isTree()}">
                <s:div id="#{renderer.id}TreeTabPane" rendered="#{renderer.isTree()}">
                    <s:div id="#{renderer.id}TreeTabOptions" styleClass="document-viewer-options #{renderer.styleClass}-options">
                        <s:div  rendered="#{opt.hasRenderingModes()}" style="float: left; margin-right: 2em; margin-top: 7px;">
                            <h:selectOneMenu value = "#{opt.renderingMode}" >
                                <f:selectItems value="#{renderer.getRenderingModes()}"/>
                                <a4j:ajax event="change" render="#{renderer.id}TreeTab"/>
                            </h:selectOneMenu>
                        </s:div>
                        <s:div rendered="#{opt.hasExpandAllMode()}">
                            <s:decorate template="/layout/form/_checkbox.xhtml">
                                <ui:param name="id" value="#{renderer.id}cb4"/>
                                <ui:define name="label">
                                    #{messages['net.ihe.gazelle.document.expands-all']}
                                </ui:define>
                                <h:selectBooleanCheckbox id="#{renderer.id}cb4" value="#{opt.expandsAll}">
                                    <a4j:ajax event="change" render="#{renderer.id}TreeTabPane"/>
                                </h:selectBooleanCheckbox>
                            </s:decorate>
                        </s:div>
                        <s:div rendered="#{opt.hasFilterMode()}">
                            <s:decorate template="/layout/form/_edit.xhtml">
                                <ui:param name="id" value="#{renderer.id}XpathFilter"/>
                                <ui:define name="label">
                                    #{messages['net.ihe.gazelle.document.xpath-filter']}
                                </ui:define>
                                <rich:inplaceInput  id="#{renderer.id}XpathFilter" value = "#{renderer.nodeFilter}"
                                                    defaultLabel = "${renderer.getFilterLabel()}">
                                    <a4j:ajax event="change" render="#{renderer.id}TreeTabPane"/>
                                </rich:inplaceInput>
                            </s:decorate>
                        </s:div>
                    </s:div>
                    <s:div id="#{renderer.id}TreeTab" styleClass="document-viewer #{documentViewerStyle} #{renderer.styleClass}">
                        <s:span style="width: 100%;" rendered="#{not empty opt.caption}"><h:outputText value="#{opt.caption}"/></s:span>
                        <rich:tree value="#{renderer.render(document,opt)}"
                                   var="node"
                                   style="overflow: auto;background-color:white;"
                                   toggleType="client">
                            <rich:treeNode expanded="#{opt.expandsAll}" icon="void"
                                           rendered="#{renderer.isRenderedNode(node)}">

                                <s:div rendered="#{opt.actions.download and renderer.isActionAppropriate('download',node)}" style="display: inline">
                                    <h:commandLink action="#{renderer.downloadToFile(node)}" target="_blank">
                                        <s:span title="#{messages['net.ihe.gazelle.document.download-fragment']} #{renderer.downloadFilename(node)}" styleClass="gzl-icon-download text-info"/>
                                    </h:commandLink>
                                </s:div>
                                <s:div rendered="#{opt.actions.show and renderer.isActionAppropriate('show',node)}" style="display: inline">
                                    <h:commandLink action="#{renderer.showFile(node)}" target="_blank">
                                        <s:span title="#{messages['net.ihe.gazelle.document.view-fragment']}" styleClass="gzl-icon-eye text-info"/>
                                    </h:commandLink>
                                </s:div>
                                <!--
                                <s:div rendered="#{opt.actions.validation and renderer.isActionAppropriate('validation',node)}" style="display: inline">
                                    <h:outputLink
                                            value="#{renderer.isValidatedNode.getValidationPermanentLinkFromDb(node.data.oid)}"
                                            target="_blank"
                                            rendered="#{analysisBeanGui.getValidationPermanentLinkFromDb(node.data.oid) != 'not performed'}">
                                        <s:span title="#{messages['gazelle.evs.ClickToViewValidationOutcome']}" styleClass="#{analysisBeanGui.getIconForNode(node.data)}"/>
                                    </h:outputLink>
                                </s:div>
                                <s:div rendered="#{opt.actions.validate and renderer.isActionAppropriate('validate',node)}" style="display: inline">
                                    <h:commandLink action="#{renderer.validate(node)}">
                                        <s:span title="#{messages['net.ihe.gazelle.document.validate-fragment']} #{renderer.downloadFilename(node)}" styleClass="gzl-icon-play"/>
                                    </h:commandLink>
                                </s:div>
                                -->
                                <h:outputText escape="false" value="#{renderer.renderNode(node)}"/>
                            </rich:treeNode>
                        </rich:tree>
                        <s:span style="width: 100%;" rendered="#{not empty renderer.warningCaption}"><h:outputText escape="false" value="#{renderer.warningCaption}"/></s:span>
                    </s:div>
                </s:div>
            </c:when>
            <c:otherwise>
                <s:div id="#{renderer.id}TabPane" rendered="#{not renderer.isTree()}">
                    <s:div id="#{renderer.id}TabOptions" styleClass="document-viewer-options #{renderer.styleClass}-options">
                        <s:div  rendered="#{opt.hasRenderingModes()}" style="float: left; margin-right: 2em; margin-top: 7px;">
                            <h:selectOneMenu value = "#{opt.renderingMode}" >
                                <f:selectItems value="#{renderer.getRenderingModes()}"/>
                                <a4j:ajax event="change" render="#{renderer.id}TabDocument"/>
                            </h:selectOneMenu>
                        </s:div>
                        <s:decorate template="/layout/form/_checkbox.xhtml" rendered="#{opt.hasPrettyViewMode()}" style="float: left; margin-right: 2em;">
                            <ui:param name="id" value="#{renderer.id}cb2"/>
                            <ui:define name="label">
                                #{messages['net.ihe.gazelle.document.prettify-content']}
                            </ui:define>
                            <h:selectBooleanCheckbox id="#{renderer.id}cb2" value="#{opt.prettyView}">
                                <a4j:ajax event="change" render="#{renderer.id}TabDocument,validationResultsPanel"/>
                            </h:selectBooleanCheckbox>
                        </s:decorate>
                        <s:decorate template="/layout/form/_checkbox.xhtml" rendered="#{opt.hasViewLineNumberMode()}" style="float: left; margin-right: 2em;">
                            <ui:param name="id" value="#{renderer.id}cb3"/>
                            <ui:define name="label">
                                #{messages['net.ihe.gazelle.document.view-lines-numbers']}
                            </ui:define>
                            <h:selectBooleanCheckbox id="#{renderer.id}cb3" value="#{opt.viewLineNumber}">
                                <a4j:ajax event="change" render="#{renderer.id}TabDocument"/>
                            </h:selectBooleanCheckbox>
                        </s:decorate>
                        <s:div  rendered="#{opt.hasMaxColumnsMode()}" style="float: left; margin-right: 2em; margin-top: 7px;">
                            <h:selectOneMenu value = "#{opt.maxColumns}" >
                                <f:selectItem itemValue = "20" itemLabel = "20" />
                                <f:selectItem itemValue = "40" itemLabel = "40" />
                                <f:selectItem itemValue = "60" itemLabel = "60" />
                                <f:selectItem itemValue = "80" itemLabel = "80" />
                                <a4j:ajax event="change" render="#{renderer.id}TabDocument"/>
                            </h:selectOneMenu>
                        </s:div>
                        <br/>
                    </s:div>
                    <s:div id="#{renderer.id}TabDocument" styleClass="document-viewer #{documentViewerStyle}">
                        <h:outputText id="#{renderer.id}TabDocumentContent"
                                      value="#{renderer.render(document,opt)}"
                                      escape="false"/>
                    </s:div>
                </s:div>
            </c:otherwise>
        </c:choose>
    </rich:tab>
</ui:composition>